Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 4235)
+++ palm/trunk/SOURCE/transpose.f90	(revision 4236)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added missing OpenMP directives
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -162,5 +165,4 @@
 !--    Reorder transposed array
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, ys )
-!$OMP  DO
        DO  l = 0, pdims(2) - 1
           ys = 0 + l * ( nyn_x - nys_x + 1 )
@@ -169,4 +171,5 @@
           !$ACC PRESENT(f_out, work)
 #endif
+          !$OMP DO
           DO  i = nxl_y, nxr_y
              DO  k = nzb_y, nzt_y
@@ -176,4 +179,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
@@ -298,5 +302,4 @@
 !--    Reorder input array for transposition
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
-!$OMP  DO
        DO  l = 0, pdims(1) - 1
           xs = 0 + l * nnx
@@ -305,4 +308,5 @@
           !$ACC PRESENT(work, f_in)
 #endif
+          !$OMP DO
           DO  k = nzb_x, nzt_x
              DO  i = xs, xs + nnx - 1
@@ -312,4 +316,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
@@ -460,5 +465,4 @@
 !--    Reorder input array for transposition
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, ys )
-!$OMP  DO
        DO  l = 0, pdims(2) - 1
           ys = 0 + l * ( nyn_x - nys_x + 1 )
@@ -467,4 +471,5 @@
           !$ACC PRESENT(work, f_in)
 #endif
+          !$OMP DO
           DO  i = nxl_y, nxr_y
              DO  k = nzb_y, nzt_y
@@ -474,4 +479,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
@@ -749,5 +755,4 @@
 !--    Reorder transposed array
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, zs )
-!$OMP  DO
        DO  l = 0, pdims(1) - 1
           zs = 1 + l * ( nzt_y - nzb_y + 1 )
@@ -756,4 +761,5 @@
           !$ACC PRESENT(f_out, work)
 #endif
+          !$OMP DO
           DO  j = nys_z, nyn_z
              DO  k = zs, zs + nzt_y - nzb_y
@@ -763,4 +769,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
@@ -909,5 +916,4 @@
 !--    Reorder transposed array
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
-!$OMP  DO
        DO  l = 0, pdims(1) - 1
           xs = 0 + l * nnx
@@ -916,4 +922,5 @@
           !$ACC PRESENT(f_out, work)
 #endif
+          !$OMP DO
           DO  k = nzb_x, nzt_x
              DO  i = xs, xs + nnx - 1
@@ -923,4 +930,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
@@ -1028,5 +1036,4 @@
 !--    Reorder input array for transposition
 !$OMP  PARALLEL PRIVATE ( i, j, k, l, zs )
-!$OMP  DO
        DO  l = 0, pdims(1) - 1
           zs = 1 + l * ( nzt_y - nzb_y + 1 )
@@ -1035,4 +1042,5 @@
           !$ACC PRESENT(work, f_in)
 #endif
+          !$OMP DO
           DO  j = nys_z, nyn_z
              DO  k = zs, zs + nzt_y - nzb_y
@@ -1042,4 +1050,5 @@
              ENDDO
           ENDDO
+          !$OMP END DO NOWAIT
        ENDDO
 !$OMP  END PARALLEL
Index: palm/trunk/SOURCE/tridia_solver_mod.f90
===================================================================
--- palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 4235)
+++ palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 4236)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added missing OpenMP directives
+! 
+! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
 ! 
@@ -249,4 +252,6 @@
 #endif
 
+          !$OMP PARALLEL PRIVATE(i,j,k)
+
 !
 !--       Forward substitution
@@ -258,4 +263,5 @@
              !$ACC LOOP COLLAPSE(2)
 #endif
+             !$OMP DO
              DO  j = nys_z, nyn_z
                 DO  i = nxl_z, nxr_z
@@ -286,4 +292,5 @@
              !$ACC LOOP COLLAPSE(2)
 #endif
+             !$OMP DO
              DO  j = nys_z, nyn_z
                 DO  i = nxl_z, nxr_z
@@ -301,4 +308,6 @@
           !$ACC END PARALLEL
 #endif
+
+          !$OMP END PARALLEL
 
 !