Index: palm/trunk/TESTS/cases/urban_environment/MONITORING/urban_environment_rc
===================================================================
--- palm/trunk/TESTS/cases/urban_environment/MONITORING/urban_environment_rc	(revision 4227)
+++ palm/trunk/TESTS/cases/urban_environment/MONITORING/urban_environment_rc	(revision 4238)
@@ -4,6 +4,6 @@
  ******************************    --------------------------------------------
 
- Date:               2019-08-23    Run:       urban_environment__gfortran_defaul
- Time:                 14:06:33    Run-No.:   00
+ Date:               2019-09-25    Run:       urban_environment__gfortran_defaul
+ Time:                 17:14:46    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
@@ -219,12 +219,12 @@
  -------------------
 
-    Geograph. latitude  :   latitude  = 52.5 degr
-    Geograph. longitude :   longitude = 13.3 degr
+    Geograph. latitude  :   latitude  =  52.5 degr
+    Geograph. longitude :   longitude =  13.3 degr
+    Rotation angle      :   rotation_angle =   0.0 degr
     Angular velocity    :   omega  = 0.729E-04 rad/s
     Coriolis parameter  :   f      =  0.000116 1/s
                             f*     =  0.000089 1/s
 
-    Day of the year at model start :   day_init      =      65
-    UTC time at model start        :   time_utc_init = 36000.0 s
+    Date and time at model start : 2019-03-06 10:00:00 +00
 
     Gravity             :   g      =  9.8 m/s**2
@@ -376,5 +376,5 @@
   0     29 00:00:21.98   0.7580A  -2.3753  -1.2417   1.0350  0.072  0.42  -0.853E+00     40.  0.136E+01  0.226E-01  0.828E-03  0.177E-03   60   9  12   11  14   0   11  14  18    0.000    0.000       0
   0     30 00:00:22.74   0.7580A  -2.3754  -1.2416   1.0314  0.072  0.42  -0.853E+00     40.  0.136E+01  0.230E-01  0.832E-03  0.176E-03   60   8  11   11  14   0   11  14  18    0.000    0.000       0
-  0     31 00:00:23.49   0.7580A  -2.3755  -1.2416   1.0241  0.071  0.42  -0.853E+00     40.  0.136E+01  0.234E-01  0.836E-03  0.175E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
+  0     31 00:00:23.49   0.7580A  -2.3755  -1.2416   1.0242  0.071  0.42  -0.853E+00     40.  0.136E+01  0.234E-01  0.836E-03  0.175E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
   0     32 00:00:24.25   0.7580A  -2.3755  -1.2416   1.0145  0.071  0.43  -0.853E+00     40.  0.136E+01  0.239E-01  0.840E-03  0.174E-03   60   8  10   11  14   0   11  14  18    0.000    0.000       0
   0     33 00:00:25.01   0.7580A  -2.3756  -1.2415   1.0039  0.071  0.43  -0.853E+00     40.  0.136E+01  0.243E-01  0.845E-03  0.173E-03   60   7   9   11  14   0   11  14  18    0.000    0.000       0
@@ -389,13 +389,13 @@
   0     42 00:00:31.83   0.7570A  -2.3763  -1.2197   1.0752  0.069  0.46  -0.854E+00     40.  0.136E+01  0.282E-01  0.879E-03  0.168E-03   60   4   1   11  13   0   11  14  16    0.000    0.000       0
   0     43 00:00:32.59   0.7570A  -2.3764  -1.2166   1.0973  0.069  0.46  -0.855E+00     40.  0.136E+01  0.287E-01  0.882E-03  0.168E-03   60   4   0   11  13   0   12  14  16    0.000    0.000       0
-  0     44 00:00:33.35   0.7570A  -2.3765  -1.2114   1.1174  0.069  0.46  -0.855E+00     40.  0.136E+01  0.291E-01  0.887E-03  0.167E-03   60   4  19   11  13   0   12  14  16    0.000    0.000       0
+  0     44 00:00:33.35   0.7570A  -2.3765  -1.2114   1.1175  0.069  0.46  -0.855E+00     40.  0.136E+01  0.291E-01  0.887E-03  0.167E-03   60   4  19   11  13   0   12  14  16    0.000    0.000       0
   0     45 00:00:34.10   0.7570A  -2.3765  -1.2040   1.1335  0.069  0.47  -0.856E+00     40.  0.136E+01  0.296E-01  0.892E-03  0.168E-03   60   3  18   11  13   0   12  14  16    0.000    0.000       0
   0     46 00:00:34.86   0.7570A  -2.3766  -1.1946   1.1436  0.069  0.47  -0.857E+00     40.  0.136E+01  0.300E-01  0.899E-03  0.168E-03   60   3  17   11  13   0   12  14  16    0.000    0.000       0
-  0     47 00:00:35.62   0.7570A  -2.3767  -1.1832   1.1523  0.069  0.47  -0.857E+00     40.  0.136E+01  0.305E-01  0.905E-03  0.168E-03   60   3  17   11  13   0   13  14  16    0.000    0.000       0
-  0     48 00:00:36.37   0.7570A  -2.3768  -1.1697   1.1649  0.069  0.47  -0.858E+00     40.  0.136E+01  0.310E-01  0.913E-03  0.168E-03   60   3  16   11  13   0   13  14  16    0.000    0.000       0
+  0     47 00:00:35.62   0.7570A  -2.3767  -1.1831   1.1523  0.069  0.47  -0.857E+00     40.  0.136E+01  0.305E-01  0.905E-03  0.168E-03   60   3  17   11  13   0   13  14  16    0.000    0.000       0
+  0     48 00:00:36.37   0.7570A  -2.3768  -1.1696   1.1649  0.069  0.47  -0.858E+00     40.  0.136E+01  0.310E-01  0.913E-03  0.168E-03   60   3  16   11  13   0   13  14  16    0.000    0.000       0
   0     49 00:00:37.13   0.7570A  -2.3768  -1.1542   1.1783  0.069  0.48  -0.859E+00     40.  0.136E+01  0.314E-01  0.920E-03  0.168E-03   60   2  15   11  13   0   16  14  17    0.000    0.000       0
-  0     50 00:00:37.89   0.7570A  -2.3769  -1.1370   1.1979  0.069  0.48  -0.858E+00     40.  0.136E+01  0.319E-01  0.929E-03  0.169E-03   60   2  14   11  13   0   16  14  17    0.000    0.000       0
+  0     50 00:00:37.89   0.7570A  -2.3769  -1.1369   1.1980  0.069  0.48  -0.858E+00     40.  0.136E+01  0.319E-01  0.929E-03  0.169E-03   60   2  14   11  13   0   16  14  17    0.000    0.000       0
   0     51 00:00:38.64   0.7570A  -2.3770  -1.1182   1.2157  0.069  0.48  -0.857E+00     40.  0.136E+01  0.324E-01  0.938E-03  0.169E-03   60   2  13   11  13   0   17  14  17    0.000    0.000       0
-  0     52 00:00:39.40   0.7570A  -2.3771  -1.0980   1.2362  0.069  0.49  -0.856E+00     40.  0.136E+01  0.328E-01  0.946E-03  0.169E-03   60   1  12   11  13   0   17  14  17    0.000    0.000       0
+  0     52 00:00:39.40   0.7570A  -2.3771  -1.0979   1.2362  0.069  0.49  -0.856E+00     40.  0.136E+01  0.328E-01  0.946E-03  0.169E-03   60   1  12   11  13   0   17  14  17    0.000    0.000       0
   0     53 00:00:40.16   0.7570A  -2.3771  -1.0765   1.2515  0.069  0.49  -0.856E+00     40.  0.136E+01  0.333E-01  0.955E-03  0.170E-03   60   1  11   11  13   0   17  14  17    0.000    0.000       0
   0     54 00:00:40.92   0.7570A  -2.3772  -1.0761   1.2611  0.069  0.49  -0.855E+00     40.  0.136E+01  0.338E-01  0.965E-03  0.171E-03   60   1  10   13  14   0   17  14  17    0.000    0.000       0
@@ -403,6 +403,6 @@
   0     56 00:00:42.43   0.7570A  -2.3774  -1.0716   1.2673  0.069  0.50  -0.855E+00     40.  0.136E+01  0.348E-01  0.985E-03  0.172E-03   60   0   8   13  14   0   18  14  17    0.000    0.000       0
   0     57 00:00:43.19   0.7570A  -2.3774  -1.0668   1.2713  0.069  0.50  -0.855E+00     40.  0.136E+01  0.352E-01  0.995E-03  0.172E-03   60   0   8   13  14   0   18  14  17    0.000    0.000       0
-  0     58 00:00:43.94   0.7570A  -2.3775  -1.0608   1.2682  0.069  0.54  -0.855E+00     48.  0.136E+01  0.357E-01  0.100E-02  0.173E-03   60   0   7   13  14   0   18  14  17    0.000    0.000       0
-  0     59 00:00:44.70   0.7570A  -2.3776  -1.0544   1.2766  0.069  0.54  -0.855E+00     48.  0.136E+01  0.362E-01  0.101E-02  0.173E-03   60  19   6   14  14   0   19  14  18    0.000    0.000       0
+  0     58 00:00:43.94   0.7570A  -2.3775  -1.0608   1.2683  0.069  0.54  -0.855E+00     48.  0.136E+01  0.357E-01  0.100E-02  0.173E-03   60   0   7   13  14   0   18  14  17    0.000    0.000       0
+  0     59 00:00:44.70   0.7570A  -2.3776  -1.0544   1.2767  0.069  0.54  -0.855E+00     48.  0.136E+01  0.362E-01  0.101E-02  0.173E-03   60  19   6   14  14   0   19  14  18    0.000    0.000       0
   0     60 00:00:45.46   0.7570A  -2.3777  -1.0546   1.2902  0.069  0.55  -0.855E+00     48.  0.136E+01  0.367E-01  0.102E-02  0.174E-03   60  19   5   14  14   0   19  14  18    0.000    0.000       0
   0     61 00:00:46.21   0.7570A  -2.3777  -1.0559   1.2971  0.069  0.55  -0.855E+00     48.  0.136E+01  0.372E-01  0.103E-02  0.174E-03   60  19   5   14  14   0   19  14  18    0.000    0.000       0
@@ -411,30 +411,30 @@
   0     64 00:00:48.49   0.7570A  -2.3780  -1.0644   1.2756  0.069  0.52  -0.856E+00     40.  0.136E+01  0.387E-01  0.105E-02  0.176E-03   60  18   2   14  14   0   19  14  18    0.000    0.000       0
   0     65 00:00:49.24   0.7570A  -2.3780  -1.0669   1.2562  0.069  0.52  -0.857E+00     40.  0.135E+01  0.391E-01  0.106E-02  0.176E-03   60  18   1   14  14   0   19  14  18    0.000    0.000       0
-  0     66 00:00:50.00   0.7570A  -2.3781  -1.0743   1.2325  0.069  0.52  -0.859E+00     40.  0.135E+01  0.396E-01  0.107E-02  0.176E-03   60  17   0   15  14   0   19  14  18    0.000    0.000       0
-  0     67 00:00:50.76   0.7570A  -2.3782  -1.0795   1.2056  0.069  0.53  -0.861E+00     40.  0.135E+01  0.401E-01  0.108E-02  0.177E-03   60  17  19   15  14   0   19  14  18    0.000    0.000       0
+  0     66 00:00:50.00   0.7570A  -2.3781  -1.0743   1.2325  0.069  0.52  -0.858E+00     40.  0.135E+01  0.396E-01  0.107E-02  0.176E-03   60  17   0   15  14   0   19  14  18    0.000    0.000       0
+  0     67 00:00:50.76   0.7570A  -2.3782  -1.0795   1.2056  0.069  0.52  -0.861E+00     40.  0.135E+01  0.401E-01  0.108E-02  0.177E-03   60  17  19   15  14   0   19  14  18    0.000    0.000       0
   0     68 00:00:51.51   0.7570A  -2.3783  -1.0822   1.1770  0.069  0.53  -0.865E+00     40.  0.135E+01  0.406E-01  0.109E-02  0.177E-03   60  17  19   15  13   0   19  14  18    0.000    0.000       0
   0     69 00:00:52.27   0.7570A  -2.3783  -1.0898   1.1475  0.069  0.53  -0.872E+00     40.  0.135E+01  0.411E-01  0.109E-02  0.177E-03   60  16  17   15  13   0   19  14  18    0.000    0.000       0
-  0     70 00:00:53.03   0.7570A  -2.3784  -1.0938   1.1182  0.069  0.53  -0.934E+00     40.  0.135E+01  0.415E-01  0.110E-02  0.178E-03   60  16  16   15  13   0   19  14  18    0.000    0.000       0
+  0     70 00:00:53.03   0.7570A  -2.3784  -1.0938   1.1181  0.069  0.53  -0.934E+00     40.  0.135E+01  0.415E-01  0.110E-02  0.178E-03   60  16  16   15  13   0   19  14  18    0.000    0.000       0
   0     71 00:00:53.78   0.7570A  -2.3785  -1.0941   1.0897  0.069  0.53  -0.935E+00     40.  0.135E+01  0.420E-01  0.111E-02  0.178E-03   60  16  16   15  13   0   19  14  18    0.000    0.000       0
   0     72 00:00:54.54   0.7570A  -2.3785  -1.0911   1.1100  0.069  0.53  -0.918E+00     40.  0.135E+01  0.424E-01  0.112E-02  0.178E-03   60  15  14   15  13   0    6  13   2    0.000    0.000       0
   0     73 00:00:55.30   0.7570A  -2.3786  -1.0856   1.1445  0.069  0.53  -0.884E+00     40.  0.135E+01  0.429E-01  0.112E-02  0.179E-03   60  15  14   15  13   0    6  13   2    0.000    0.000       0
   0     74 00:00:56.06   0.7570A  -2.3787  -1.0786   1.1761  0.069  0.53  -0.879E+00     40.  0.135E+01  0.433E-01  0.113E-02  0.179E-03   60  15  13   15  13   0    6  13   2    0.000    0.000       0
-  0     75 00:00:56.81   0.7570A  -2.3788  -1.0708   1.2044  0.069  0.53  -0.887E+00     40.  0.135E+01  0.438E-01  0.114E-02  0.179E-03   60  14  12   15  13   0    6  13   2    0.000    0.000       0
+  0     75 00:00:56.81   0.7570A  -2.3788  -1.0708   1.2043  0.069  0.53  -0.886E+00     40.  0.135E+01  0.438E-01  0.114E-02  0.179E-03   60  14  12   15  13   0    6  13   2    0.000    0.000       0
   0     76 00:00:57.57   0.7570A  -2.3788  -1.0626   1.2287  0.069  0.53  -0.896E+00     40.  0.135E+01  0.442E-01  0.115E-02  0.180E-03   60  14  11   15  13   0    6  13   2    0.000    0.000       0
   0     77 00:00:58.33   0.7570A  -2.3789  -1.0544   1.2488  0.069  0.53  -0.875E+00     40.  0.135E+01  0.446E-01  0.116E-02  0.180E-03   60  14  10   15  13   0    6  13   2    0.000    0.000       0
-  0     78 00:00:59.08   0.7570A  -2.3790  -1.0462   1.2645  0.069  0.53  -0.863E+00     40.  0.135E+01  0.451E-01  0.117E-02  0.180E-03   60  14  10   15  13   0    6  13   2    0.000    0.000       0
-  0     79 00:00:59.84   0.7570A  -2.3791  -1.0380   1.2757  0.069  0.53  -0.857E+00     40.  0.135E+01  0.455E-01  0.118E-02  0.181E-03   60  13   8   15  13   0    6  13   2    0.000    0.000       0
-  0     80 00:01:00.60   0.7570A  -2.3791  -1.0298   1.2831  0.069  0.54  -0.853E+00     40.  0.135E+01  0.459E-01  0.118E-02  0.181E-03   60  13   8   15  13   0    6  14   3    0.000    0.000       0
+  0     78 00:00:59.08   0.7570A  -2.3790  -1.0462   1.2644  0.069  0.53  -0.863E+00     40.  0.135E+01  0.451E-01  0.117E-02  0.180E-03   60  14  10   15  13   0    6  13   2    0.000    0.000       0
+  0     79 00:00:59.84   0.7570A  -2.3791  -1.0380   1.2756  0.069  0.53  -0.857E+00     40.  0.135E+01  0.455E-01  0.118E-02  0.181E-03   60  13   8   15  13   0    6  13   2    0.000    0.000       0
+  0     80 00:01:00.60   0.7570A  -2.3791  -1.0298   1.2831  0.069  0.53  -0.853E+00     40.  0.135E+01  0.459E-01  0.118E-02  0.181E-03   60  13   8   15  13   0    6  14   3    0.000    0.000       0
   0     81 00:01:01.35   0.7570A  -2.3792  -1.0355   1.3117  0.069  0.54  -0.851E+00     40.  0.135E+01  0.463E-01  0.119E-02  0.181E-03   60  13   7   18  13   0    7  13   2    0.000    0.000       0
   0     82 00:01:02.11   0.7570A  -2.3793  -1.0476   1.3367  0.069  0.54  -0.849E+00     40.  0.135E+01  0.466E-01  0.120E-02  0.181E-03   60  13   6   18  13   0    7  13   2    0.000    0.000       0
-  0     83 00:01:02.87   0.7570A  -2.3794  -1.0574   1.3575  0.069  0.54  -0.851E+00     40.  0.135E+01  0.470E-01  0.121E-02  0.181E-03   60  12   5   18  13   0    7  13   2    0.000    0.000       0
+  0     83 00:01:02.87   0.7570A  -2.3794  -1.0574   1.3574  0.069  0.54  -0.851E+00     40.  0.135E+01  0.470E-01  0.121E-02  0.181E-03   60  12   5   18  13   0    7  13   2    0.000    0.000       0
   0     84 00:01:03.63   0.7560A  -2.3794  -1.0640   1.3739  0.069  0.54  -0.858E+00     40.  0.135E+01  0.474E-01  0.121E-02  0.181E-03   60  12   4   18  13   0    7  13   2    0.000    0.000       0
-  0     85 00:01:04.38   0.7560A  -2.3795  -1.0670   1.3859  0.069  0.54  -0.878E+00     40.  0.135E+01  0.477E-01  0.122E-02  0.181E-03   60  12   4   18  13   0    7  13   2    0.000    0.000       0
+  0     85 00:01:04.38   0.7560A  -2.3795  -1.0670   1.3859  0.069  0.54  -0.877E+00     40.  0.135E+01  0.477E-01  0.122E-02  0.181E-03   60  12   4   18  13   0    7  13   2    0.000    0.000       0
   0     86 00:01:05.14   0.7560A  -2.3796  -1.0665   1.3937  0.070  0.55  -0.856E+00     40.  0.135E+01  0.481E-01  0.122E-02  0.181E-03   60  11   2   18  13   0    7  13   2    0.000    0.000       0
   0     87 00:01:05.89   0.7560A  -2.3797  -1.0659   1.3972  0.070  0.55  -0.845E+00     40.  0.135E+01  0.484E-01  0.123E-02  0.181E-03   60  11   1   17  12   0    7  13   2    0.000    0.000       0
   0     88 00:01:06.65   0.7560A  -2.3797  -1.0724   1.3996  0.070  0.55  -0.840E+00     40.  0.135E+01  0.487E-01  0.123E-02  0.181E-03   60  11   1   17  12   0    6  14   3    0.000    0.000       0
-  0     89 00:01:07.41   0.7560A  -2.3798  -1.0757   1.4163  0.070  0.55  -0.837E+00     40.  0.135E+01  0.490E-01  0.124E-02  0.181E-03   60  10  19   17  12   0    7  14   3    0.000    0.000       0
+  0     89 00:01:07.41   0.7560A  -2.3798  -1.0757   1.4162  0.070  0.55  -0.837E+00     40.  0.135E+01  0.490E-01  0.124E-02  0.181E-03   60  10  19   17  12   0    7  14   3    0.000    0.000       0
   0     90 00:01:08.16   0.7560A  -2.3799  -1.0757   1.4303  0.070  0.56  -0.835E+00     40.  0.135E+01  0.493E-01  0.124E-02  0.181E-03   60  10  19   17  12   0    7  14   3    0.000    0.000       0
   0     91 00:01:08.92   0.7560A  -2.3800  -1.0818   1.4406  0.070  0.56  -0.833E+00     40.  0.135E+01  0.496E-01  0.125E-02  0.181E-03   60  10  18   13  13   0    7  14   3    0.000    0.000       0
-  0     92 00:01:09.67   0.7560A  -2.3800  -1.0917   1.4476  0.070  0.56  -0.831E+00     40.  0.135E+01  0.499E-01  0.125E-02  0.182E-03   60   9  16   13  13   0    7  14   3    0.000    0.000       0
+  0     92 00:01:09.67   0.7560A  -2.3800  -1.0916   1.4476  0.070  0.56  -0.831E+00     40.  0.135E+01  0.499E-01  0.125E-02  0.182E-03   60   9  16   13  13   0    7  14   3    0.000    0.000       0
   0     93 00:01:10.43   0.7560A  -2.3801  -1.0997   1.4517  0.070  0.57  -0.830E+00     40.  0.135E+01  0.501E-01  0.126E-02  0.182E-03   60   9  16   13  13   0    7  14   3    0.000    0.000       0