Index: palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4238)
+++ palm/trunk/TESTS/cases/urban_environment_salsa/MONITORING/urban_environment_salsa_rc	(revision 4239)
@@ -1,9 +1,9 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4222M       *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 3915M       *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2019-09-10    Run:       urban_environment_salsa__gfortran_
- Time:                 17:55:12    Run-No.:   00
+ Date:               2019-09-26    Run:       urban_environment_salsa__gfortran_
+ Time:                 10:42:08    Run-No.:   00
  Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
@@ -343,5 +343,5 @@
   0     13 00:00:15.58   1.3200A   1.3623   0.8811   0.9030  0.082  0.00  -0.484E+00      4.  0.313E+00  0.690E-01  0.550E-02  0.146E-02   16   1  15    8   5  14   15   2  14    0.000    0.000       0
   0     14 00:00:16.90   1.3400A   1.3479   0.8688   0.8921  0.081  0.00  -0.480E+00      4.  0.311E+00  0.704E-01  0.552E-02  0.145E-02   16   1  15    8   5  14   15   2  14    0.000    0.000       0
-  0     15 00:00:18.24   1.3500A   1.3331   0.8549   0.8804  0.080  0.00  -0.476E+00      4.  0.309E+00  0.717E-01  0.556E-02  0.145E-02   16   1  15    8   5  14   15   2  14    0.000    0.000       0
+  0     15 00:00:18.24   1.3500A   1.3331   0.8550   0.8804  0.080  0.00  -0.476E+00      4.  0.309E+00  0.717E-01  0.556E-02  0.145E-02   16   1  15    8   5  14   15   2  14    0.000    0.000       0
   0     16 00:00:19.59   1.3600A   1.3189  -0.8433   0.8687  0.079  0.00  -0.475E+00      4.  0.306E+00  0.731E-01  0.556E-02  0.143E-02   16   1  15    7   3   5   15   2  14    0.000    0.000       0
   0     17 00:00:20.95   1.3800A   1.3050  -0.8519   0.8567  0.079  0.00  -0.474E+00      4.  0.304E+00  0.744E-01  0.554E-02  0.141E-02   16   1  15    7   3   5   15   2  14    0.000    0.000       0
@@ -357,28 +357,28 @@
   0     27 00:00:35.28   1.4500A   1.2382   0.7121   0.8576  0.074  0.00  -0.470E+00      6.  0.287E+00  0.882E-01  0.503E-02  0.109E-02   18   2   5   12   5  14   10  14   4    0.000    0.000       0
   0     28 00:00:36.74   1.4500A   1.2442   0.7006   0.9018  0.074  0.00  -0.471E+00      6.  0.285E+00  0.896E-01  0.492E-02  0.104E-02   18   2   5   12   5  14   10  14   4    0.000    0.000       0
-  0     29 00:00:38.19   1.4400A   1.2487   0.6854   0.9548  0.074  0.00  -0.470E+00      6.  0.284E+00  0.909E-01  0.484E-02  0.100E-02   18   2   5   12   5  14   11  14   4    0.000    0.000       0
-  0     30 00:00:39.63   1.4400A   1.2512   0.6695   1.0068  0.074  0.00  -0.470E+00      6.  0.283E+00  0.923E-01  0.473E-02  0.955E-03   18   2   5   11   5  14   11  14   4    0.000    0.000       0
+  0     29 00:00:38.19   1.4400A   1.2487   0.6854   0.9549  0.074  0.00  -0.470E+00      6.  0.284E+00  0.909E-01  0.484E-02  0.100E-02   18   2   5   12   5  14   11  14   4    0.000    0.000       0
+  0     30 00:00:39.63   1.4400A   1.2512   0.6695   1.0069  0.074  0.00  -0.470E+00      6.  0.283E+00  0.923E-01  0.473E-02  0.955E-03   18   2   5   11   5  14   11  14   4    0.000    0.000       0
   0     31 00:00:41.07   1.4400A   1.2532   0.6498   1.0521  0.074  0.00  -0.471E+00      6.  0.282E+00  0.937E-01  0.466E-02  0.916E-03   18   2   6   11   5  14   11  14   4    0.000    0.000       0
-  0     32 00:00:42.51   1.4300A   1.2566   0.6250   1.0927  0.073  0.00  -0.472E+00      6.  0.281E+00  0.950E-01  0.458E-02  0.878E-03   18   2   6   11   5  14   12  14   4    0.000    0.000       0
-  0     33 00:00:43.94   1.4400A   1.2540  -0.6221   1.1443  0.073  0.00  -0.472E+00      6.  0.281E+00  0.964E-01  0.448E-02  0.836E-03   18   2   6    6   4   9   12  14   4    0.000    0.000       0
-  0     34 00:00:45.38   1.4500A   1.2448  -0.6268   1.1866  0.073  0.00  -0.474E+00      6.  0.280E+00  0.978E-01  0.443E-02  0.800E-03   18   2   6    6   3  10   11  14   3    0.000    0.000       0
-  0     35 00:00:46.83   1.4600A   1.2295  -0.6599   1.2292  0.073  0.00  -0.478E+00      6.  0.279E+00  0.991E-01  0.440E-02  0.762E-03   18   2   6    6   3  10   13  14   4    0.000    0.000       0
-  0     36 00:00:48.29   1.4200A   1.2284  -0.6893   1.2690  0.073  0.00  -0.491E+00      6.  0.279E+00  0.101E+00  0.437E-02  0.722E-03   18   3   6    6   3  10   13  14   4    0.000    0.000       0
-  0     37 00:00:49.71   1.3900A   1.2317  -0.7097   1.2975  0.073  0.00  -0.483E+00      6.  0.278E+00  0.102E+00  0.421E-02  0.664E-03   18   3   6    6   3  10   14  14   4    0.000    0.000       0
-  0     38 00:00:51.10   1.3400A   1.2352  -0.7189   1.3405  0.072  0.00  -0.484E+00      6.  0.278E+00  0.103E+00  0.409E-02  0.610E-03   18   3   7    5   4  10   14  14   4    0.000    0.000       0
-  0     39 00:00:52.44   1.3300A   1.2407  -0.7297   1.3576  0.072  0.00  -0.486E+00     10.  0.278E+00  0.104E+00  0.394E-02  0.555E-03   18   3   7    5   4  10   14  14   4    0.000    0.000       0
-  0     40 00:00:53.77   1.3100A   1.2409  -0.7377   1.3750  0.072  0.00  -0.489E+00     10.  0.277E+00  0.106E+00  0.390E-02  0.518E-03   18   3   7    5   4  10   15  14   4    0.000    0.000       0
-  0     41 00:00:55.08   1.2800A   1.2350  -0.7511   1.4069  0.072  0.00  -0.491E+00     10.  0.277E+00  0.107E+00  0.384E-02  0.482E-03   18   3   7    6   3  11   15  14   4    0.000    0.000       0
-  0     42 00:00:56.36   1.2400A   1.2236  -0.7700   1.4491  0.072  0.00  -0.495E+00     10.  0.277E+00  0.108E+00  0.376E-02  0.447E-03   18   3   7    6   3  11   13  14   4    0.000    0.000       0
-  0     43 00:00:57.60   1.2000A   1.2191  -0.8032   1.5038  0.072  0.00  -0.499E+00     10.  0.277E+00  0.109E+00  0.367E-02  0.412E-03   18   3   8    5   4  11   13  14   4    0.000    0.000       0
-  0     44 00:00:58.80   1.1700A   1.2092  -0.8353   1.5332  0.072  0.00  -0.504E+00     10.  0.277E+00  0.110E+00  0.357E-02  0.381E-03   18   3   8    5   4  11   13  14   4    0.000    0.000       0
-  0     45 00:00:59.97   1.1600A   1.1987  -0.8607   1.5490  0.071  0.00  -0.506E+00     10.  0.277E+00  0.111E+00  0.350E-02  0.357E-03   19   2   8    5   4  11   14  14   4    0.000    0.000       0
-  0     46 00:01:01.13   1.1700A   1.1972  -0.8763   1.5335  0.071  0.00  -0.506E+00     10.  0.276E+00  0.111E+00  0.349E-02  0.341E-03    6   6  10    5   4  11   14  14   4    0.000    0.000       0
-  0     47 00:01:02.30   1.2200A   1.1998  -0.8796   1.4803  0.071  0.00  -0.505E+00     10.  0.276E+00  0.112E+00  0.355E-02  0.333E-03    6   6  10    5   4  11   14  14   4    0.000    0.000       0
-  0     48 00:01:03.52   1.2800A   1.1981  -0.8845   1.4101  0.071  0.00  -0.506E+00     10.  0.276E+00  0.113E+00  0.374E-02  0.340E-03    6   6  10    4   4  11   11  14   5    0.000    0.000       0
-  0     49 00:01:04.80   1.2100A   1.1916  -0.8816   1.4913  0.071  0.00  -0.506E+00     10.  0.276E+00  0.114E+00  0.400E-02  0.356E-03    6   6  10    4   4  11   12  14   5    0.000    0.000       0
-  0     50 00:01:06.01   1.1600A   1.1878  -0.8666   1.5551  0.071  0.00  -0.506E+00     10.  0.276E+00  0.114E+00  0.389E-02  0.348E-03   13  11   9    4   4  11   13  14   5    0.000    0.000       0
-  0     51 00:01:07.17   1.1400A   1.1899  -0.8906   1.5798  0.071  0.07  -0.505E+00     10.  0.276E+00  0.115E+00  0.382E-02  0.342E-03   13  11  10    5   3  12   14  14   5    0.000    0.000       0
-  0     52 00:01:08.31   1.1400A   1.1965  -0.9240   1.5795  0.071  0.09  -0.505E+00     10.  0.275E+00  0.115E+00  0.383E-02  0.342E-03   13  11  10    5   3  12   14  14   5    0.000    0.000       0
-  0     53 00:01:09.45   1.1800A   1.2005  -0.9455   1.5252  0.071  0.10  -0.504E+00     10.  0.275E+00  0.116E+00  0.391E-02  0.350E-03   13  11  10    4   4  12   15  14   5    0.000    0.000       0
-  0     54 00:01:10.63   1.2500A   1.2110  -0.9546   1.4396  0.071  0.10  -0.504E+00     10.  0.275E+00  0.116E+00  0.413E-02  0.370E-03   13  12  11    4   4  12   15  14   5    0.000    0.000       0
+  0     32 00:00:42.51   1.4300A   1.2566   0.6250   1.0928  0.073  0.00  -0.471E+00      6.  0.281E+00  0.950E-01  0.458E-02  0.878E-03   18   2   6   11   5  14   12  14   4    0.000    0.000       0
+  0     33 00:00:43.94   1.4400A   1.2540  -0.6223   1.1443  0.073  0.00  -0.472E+00      6.  0.281E+00  0.964E-01  0.448E-02  0.836E-03   18   2   6    6   4   9   12  14   4    0.000    0.000       0
+  0     34 00:00:45.38   1.4500A   1.2448  -0.6272   1.1867  0.073  0.00  -0.474E+00      6.  0.280E+00  0.977E-01  0.443E-02  0.800E-03   18   2   6    6   3  10   11  14   3    0.000    0.000       0
+  0     35 00:00:46.83   1.4600A   1.2295  -0.6604   1.2293  0.073  0.00  -0.478E+00      6.  0.279E+00  0.991E-01  0.440E-02  0.762E-03   18   2   6    6   3  10   13  14   4    0.000    0.000       0
+  0     36 00:00:48.29   1.4200A   1.2284  -0.6898   1.2691  0.073  0.00  -0.491E+00      6.  0.279E+00  0.100E+00  0.437E-02  0.722E-03   18   3   6    6   3  10   13  14   4    0.000    0.000       0
+  0     37 00:00:49.71   1.3900A   1.2317  -0.7102   1.2976  0.073  0.00  -0.483E+00      6.  0.278E+00  0.102E+00  0.421E-02  0.664E-03   18   3   6    6   3  10   14  14   4    0.000    0.000       0
+  0     38 00:00:51.10   1.3400A   1.2352  -0.7193   1.3406  0.072  0.00  -0.484E+00      6.  0.278E+00  0.103E+00  0.409E-02  0.610E-03   18   3   7    5   4  10   14  14   4    0.000    0.000       0
+  0     39 00:00:52.44   1.3300A   1.2408  -0.7301   1.3578  0.072  0.00  -0.486E+00     10.  0.278E+00  0.104E+00  0.394E-02  0.555E-03   18   3   7    5   4  10   14  14   4    0.000    0.000       0
+  0     40 00:00:53.77   1.3100A   1.2409  -0.7383   1.3752  0.072  0.00  -0.489E+00     10.  0.277E+00  0.106E+00  0.390E-02  0.518E-03   18   3   7    5   4  10   15  14   4    0.000    0.000       0
+  0     41 00:00:55.08   1.2800A   1.2351  -0.7513   1.4071  0.072  0.00  -0.491E+00     10.  0.277E+00  0.107E+00  0.384E-02  0.482E-03   18   3   7    6   3  11   15  14   4    0.000    0.000       0
+  0     42 00:00:56.36   1.2400A   1.2236  -0.7700   1.4495  0.072  0.00  -0.495E+00     10.  0.277E+00  0.108E+00  0.376E-02  0.447E-03   18   3   7    6   3  11   13  14   4    0.000    0.000       0
+  0     43 00:00:57.60   1.2000A   1.2192  -0.8028   1.5040  0.072  0.00  -0.499E+00     10.  0.277E+00  0.109E+00  0.367E-02  0.412E-03   18   3   8    5   4  11   13  14   4    0.000    0.000       0
+  0     44 00:00:58.80   1.1700A   1.2093  -0.8350   1.5334  0.072  0.00  -0.504E+00     10.  0.277E+00  0.110E+00  0.357E-02  0.381E-03   18   3   8    5   4  11   13  14   4    0.000    0.000       0
+  0     45 00:00:59.97   1.1600A   1.1987  -0.8605   1.5491  0.071  0.00  -0.506E+00     10.  0.277E+00  0.111E+00  0.350E-02  0.357E-03   19   2   8    5   4  11   14  14   4    0.000    0.000       0
+  0     46 00:01:01.13   1.1700A   1.1976  -0.8763   1.5334  0.071  0.00  -0.506E+00     10.  0.276E+00  0.111E+00  0.349E-02  0.341E-03    6   6  10    5   4  11   14  14   4    0.000    0.000       0
+  0     47 00:01:02.30   1.2200A   1.2002  -0.8796   1.4801  0.071  0.00  -0.505E+00     10.  0.276E+00  0.112E+00  0.355E-02  0.333E-03    6   6  10    5   4  11   14  14   4    0.000    0.000       0
+  0     48 00:01:03.52   1.2800A   1.1985  -0.8848   1.4105  0.071  0.00  -0.506E+00     10.  0.276E+00  0.113E+00  0.374E-02  0.340E-03    6   6  10    4   4  11   11  14   5    0.000    0.000       0
+  0     49 00:01:04.80   1.2100A   1.1920  -0.8819   1.4918  0.071  0.00  -0.507E+00     10.  0.276E+00  0.114E+00  0.400E-02  0.356E-03    6   6  10    4   4  11   12  14   5    0.000    0.000       0
+  0     50 00:01:06.01   1.1600A   1.1878  -0.8670   1.5556  0.071  0.00  -0.506E+00     10.  0.276E+00  0.114E+00  0.389E-02  0.348E-03   13  11   9    4   4  11   13  14   5    0.000    0.000       0
+  0     51 00:01:07.17   1.1400A   1.1898  -0.8896   1.5802  0.071  0.07  -0.505E+00     10.  0.276E+00  0.115E+00  0.382E-02  0.342E-03   13  11  10    5   3  12   14  14   5    0.000    0.000       0
+  0     52 00:01:08.31   1.1400A   1.1965  -0.9231   1.5795  0.071  0.09  -0.505E+00     10.  0.275E+00  0.115E+00  0.383E-02  0.342E-03   13  11  10    5   3  12   14  14   5    0.000    0.000       0
+  0     53 00:01:09.45   1.1800A   1.2005  -0.9448   1.5249  0.071  0.10  -0.504E+00     10.  0.275E+00  0.116E+00  0.391E-02  0.350E-03   13  11  10    4   4  12   15  14   5    0.000    0.000       0
+  0     54 00:01:10.63   1.2500A   1.2111  -0.9540   1.4388  0.071  0.10  -0.504E+00     10.  0.275E+00  0.116E+00  0.413E-02  0.370E-03   13  12  11    4   4  12   15  14   5    0.000    0.000       0