Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 4262)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 4264)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! corrected error message string
+! 
+! 4241 2019-09-27 06:32:47Z raasch
 ! Check added to ensure that subdomain grid has at least the size as given by the number
 ! of ghost points
@@ -300,10 +303,10 @@
     IF ( MOD( nx+1 , pdims(1) ) /= 0 )  THEN
        WRITE( message_string, * ) 'x-direction: gridpoint number (',nx+1,') ', &
-                               'is not an& integral divisor of the number ',    &
-                               'of processors (', pdims(1),')'
+                                  'is not an& integral multiple of the number',&
+                                  ' of processors (',pdims(1),')'
        CALL message( 'init_pegrid', 'PA0225', 1, 2, 0, 6, 0 )
     ELSE
        nnx  = ( nx + 1 ) / pdims(1)
-    ENDIF    
+    ENDIF
 
 !
@@ -318,10 +321,10 @@
     IF ( MOD( ny+1 , pdims(2) ) /= 0 )  THEN
        WRITE( message_string, * ) 'y-direction: gridpoint number (',ny+1,') ', &
-                           'is not an& integral divisor of the number of',      &
-                           'processors (', pdims(2),')'
+                                  'is not an& integral multiple of the number',&
+                                  ' of processors (',pdims(2),')'
        CALL message( 'init_pegrid', 'PA0227', 1, 2, 0, 6, 0 )
     ELSE
        nny  = ( ny + 1 ) / pdims(2)
-    ENDIF    
+    ENDIF
 
 !
@@ -363,7 +366,7 @@
        IF ( pdims(2) /= 1 )  THEN
           IF ( MOD( nz , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition z --> x:',              &
-                       '& nz=',nz,' is not an integral divisior of pdims(1)=', &
-                                                                   pdims(1)
+             WRITE( message_string, * ) 'transposition z --> x:& ',              &
+                                        'nz=',nz,' is not an integral multiple ',&
+                                        'of pdims(1)=',pdims(1)
              CALL message( 'init_pegrid', 'PA0230', 1, 2, 0, 6, 0 )
           ENDIF
@@ -381,11 +384,11 @@
 
 
-    IF ( psolver == 'poisfft' )  THEN 
+    IF ( psolver == 'poisfft' )  THEN
 !
 !--    2. transposition  x --> y
        IF ( MOD( nx+1 , pdims(2) ) /= 0 )  THEN
-          WRITE( message_string, * ) 'transposition x --> y:',                 &
-                            '& nx+1=',nx+1,' is not an integral divisor of ',  &
-                            'pdims(2)=',pdims(2)
+          WRITE( message_string, * ) 'transposition x --> y:& ',              &
+                                     'nx+1=',nx+1,' is not an integral ',     &
+                                     'multiple of pdims(2)=',pdims(2)
           CALL message( 'init_pegrid', 'PA0231', 1, 2, 0, 6, 0 )
        ENDIF
@@ -399,5 +402,5 @@
        sendrecvcount_xy = nnx_y * nny_x * nnz_y
 !
-!--    3. transposition  y --> z  
+!--    3. transposition  y --> z
 !--    (ELSE:  x --> y  in case of 1D-decomposition along x)
        nxl_z = nxl_y
@@ -414,7 +417,7 @@
 !--       along x, except that the uptream-spline method is switched on
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition y --> z:',              &
-                               '& ny+1=',ny+1,' is not an integral divisor of',&
-                               ' pdims(1)=',pdims(1)
+             WRITE( message_string, * ) 'transposition y --> z:& ',            &
+                                        'ny+1=',ny+1,' is not an integral ',   &
+                                        'multiple of pdims(1)=',pdims(1)
              CALL message( 'init_pegrid', 'PA0232', 1, 2, 0, 6, 0 )
           ENDIF
@@ -425,7 +428,7 @@
 !--       This condition must be fulfilled for a 1D-decomposition along x
           IF ( MOD( ny+1 , pdims(1) ) /= 0 )  THEN
-             WRITE( message_string, * ) 'transposition x --> y:',              &
-                               '& ny+1=',ny+1,' is not an integral divisor of',&
-                               ' pdims(1)=',pdims(1)
+             WRITE( message_string, * ) 'transposition x --> y:& ',            &
+                                        'ny+1=',ny+1,' is not an integral ',   &
+                                        'multiple of pdims(1)=',pdims(1)
              CALL message( 'init_pegrid', 'PA0233', 1, 2, 0, 6, 0 )
           ENDIF
@@ -440,6 +443,6 @@
        IF ( MOD( nz, pdims(2) ) /= 0 )  THEN
           WRITE( message_string, * ) 'direct transposition z --> y (needed ',  &
-                    'for spectra): nz=',nz,' is not an integral divisor of ',  &
-                    'pdims(2)=',pdims(2)
+                                     'for spectra):& nz=',nz,' is not an ',    &
+                                     'integral multiple of pdims(2)=',pdims(2)
           CALL message( 'init_pegrid', 'PA0234', 1, 2, 0, 6, 0 )
        ELSE